<?php
namespace Aws\Sqs;

use Aws\Common\AwsClient;

/**
 * This client is used to interact with the **Amazon Simple Queue Service (Amazon SQS)**.
 */
class SqsClient extends AwsClient
{
    /**
     * Converts a queue URL into a queue ARN.
     *
     * @param string $queueUrl The queue URL to perform the action on.
     *                         Retrieved when the queue is first created.
     *
     * @return string An ARN representation of the queue URL.
     */
    public function getQueueArn($queueUrl)
    {
        return strtr($queueUrl, array(
            'http://'        => 'arn:aws:',
            'https://'       => 'arn:aws:',
            '.amazonaws.com' => '',
            '/'              => ':',
            '.'              => ':',
        ));
    }
}
